From: =?utf-8?q?Guido_G=C3=BCnther?= <agx@sigxcpu.org>
Date: Fri, 18 Dec 2020 15:27:57 +0100
Subject: leds: lm3692x: Use lookup table for exponential brightness
MIME-Version: 1.0
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: 8bit

Using ilog2() we underestimate the brightness value so use a lookup
table for common currents. Since upstream wants this to move to
userspace there's no point in doing more complicated things.

This does not affect linear mode which is the only mode available
upstream.

Signed-off-by: Guido Günther <guido.gunther@puri.sm>
---
 drivers/leds/leds-lm3692x.c | 18 ++++++++++++++++--
 1 file changed, 16 insertions(+), 2 deletions(-)

diff --git a/drivers/leds/leds-lm3692x.c b/drivers/leds/leds-lm3692x.c
index a37ed82..855e613c 100644
--- a/drivers/leds/leds-lm3692x.c
+++ b/drivers/leds/leds-lm3692x.c
@@ -370,8 +370,22 @@ static enum led_brightness lm3692x_max_brightness(struct lm3692x_led *led,
 
 	/* see p.12 of LM36922 data sheet for brightness formula */
 	if (led->brightness_ctrl & LM3692X_MAP_MODE_EXP) {
-		/*  228 =~ 1.0 / log2(1.003040572) */
-		max_code = ilog2(max_cur/50) * 228;
+		/*
+		 * Use a lookup table for common max_cur values
+		 * log2(max_cur/50)/math.log2(1.003040572)
+		 * underestimates too much otherwise
+		 */
+		switch (max_cur) {
+		case 20000:
+			max_code = 1973;
+			break;
+		case 25000:
+			max_code = 2047;
+			break;
+		default:
+			/*  228 =~ 1.0 / log2(1.003040572) */
+			max_code = ilog2(max_cur/50) * 228;
+		}
 	} else {
 		max_code = ((max_cur * 1000) - 37806) / 12195;
 	}
